
#include "general.h"
#include "palette.H"

static const char* default_color_names[] = {
    "#43cd80",		/* SeaGreen3 */
    "#8b668b",		/* plum4 */
    "#5d478b",		/* MediumPurple4 */
    "#bdd76b",		/* dark khaki */
    "#cd8162",		/* LightSalmon3 */
    "#607b8b",          /* LightSkyBlue */
    "#96cdcd",          /* PaleTurquoise3 */
    "#8b7355",          /* burlywood4 */
    "#6b7085",          /* SlateGray4 (-1, -11, -6) */
    "#9b50c5",          /* MediumOrchid3 (-25, -2, -8) */
    "#bb904f",          /* peru (-18, +11, +16) */
    "gold",
    "green",
    "DarkSeaGreen",
    "Orange",
    "DarkOliveGreen",
    "maroon",
    "RosyBrown",
    "wheat",
    "#f4a460"		/* sandy brown */
    "#ff8c00"           /* dark orange */
    "#a020f0"           /* purple */
    "#cdb79e"           /* bisque3 */
    "#cdaf95"           /* PeachPuff3 */
    "#c1cdc1"           /* honeydew3 */
    "#cdb7b5"           /* MistyRose3 */
    "#c1cdcd"           /* azure3 */
    "#3a5fcd"           /* RoyalBlue3 */
    "#00cdcd"           /* cyan3 */
    "#cdbe70"           /* LightGoldenrod3 */
    "#cdad00"           /* gold3 */
    "#bd9b9b"           /* RosyBrown3 (-16, +0, +0) */
};


Palette::Palette(int num_colors, char **clr_names)
{
    if (clr_names == NULL || num_colors <= 0) {
	color_names = (char**)default_color_names;
	total_num_colors = MAX_NUM_DEFAULT_COLORS;
    } else {
	color_names = clr_names;
	total_num_colors = num_colors;
    }
}
